Excel Export allows you to select which rows get exported to Excel.
By default, all the rows in the grid are included in the Excel export. However, you can set which rows are exported and configure how they are rendered within the Excel file.
Export Selected Rows Copy Link
By default, all visible rows are exported, but by using the onlySelected param, only the selected rows will be exported.
import {
ClientSideRowModelModule,
ColDef,
CsvExportModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowSelectionModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
]);
const columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
{ headerName: "Group", valueGetter: "data.country.charAt(0)" },
{ field: "sport", minWidth: 150 },
{ field: "gold", hide: true },
{ field: "silver", hide: true },
{ field: "bronze", hide: true },
{ field: "total", hide: true },
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
defaultColDef: {
filter: true,
minWidth: 100,
flex: 1,
},
columnDefs: columnDefs,
rowSelection: {
mode: "multiRow",
headerCheckbox: false,
},
onGridReady: (params: GridReadyEvent) => {
(document.getElementById("selectedOnly") as HTMLInputElement).checked =
true;
},
};
function onBtExport() {
gridApi!.exportDataAsExcel({
onlySelected: (document.querySelector("#selectedOnly") as HTMLInputElement)
.checked,
});
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((response) => response.json())
.then((data) =>
gridApi!.setGridOption(
"rowData",
data.filter((rec: any) => rec.country != null),
),
);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).onBtExport = onBtExport;
}
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
<div class="container">
<div class="columns">
<label class="option" for="selectedOnly"><input id="selectedOnly" type="checkbox" />Selected Rows Only</label>
<div>
<button onclick="onBtExport()" style="font-weight: bold">Export to Excel</button>
</div>
</div>
<div class="grid-wrapper">
<div id="myGrid"></div>
</div>
</div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Export Multi Line Cells Copy Link
By default Excel renders every exported value in a cell using a single line. If you need to display a cell value on multiple lines, please set the Excel Alignment wrapText option as shown in sample below.
import {
CellStyleModule,
ClientSideRowModelModule,
ColDef,
CsvExportModule,
GridApi,
GridOptions,
ICellRendererParams,
ModuleRegistry,
RowAutoHeightModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
import { MultilineCellRenderer } from "./multilineCellRenderer";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
RowAutoHeightModule,
CellStyleModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
]);
const columnDefs: ColDef[] = [
{ field: "address" },
{
headerName: "Custom column",
autoHeight: true,
valueGetter: (param) => {
return param.data.col1 + "\n" + param.data.col2;
},
cellRenderer: MultilineCellRenderer,
},
];
let gridApi: GridApi;
const gridOptions: GridOptions = {
defaultColDef: {
cellClass: "multiline",
minWidth: 100,
flex: 1,
},
columnDefs: columnDefs,
rowData: [
{
address:
"1197 Thunder Wagon Common,\nCataract, RI, \n02987-1016, US, \n(401) 747-0763",
col1: "abc",
col2: "xyz",
},
{
address:
"3685 Rocky Glade, Showtucket, NU, \nX1E-9I0, CA, \n(867) 371-4215",
col1: "abc",
col2: "xyz",
},
{
address:
"3235 High Forest, Glen Campbell, MS, \n39035-6845, US, \n(601) 638-8186",
col1: "abc",
col2: "xyz",
},
{
address:
"2234 Sleepy Pony Mall , Drain, DC, \n20078-4243, US, \n(202) 948-3634",
col1: "abc",
col2: "xyz",
},
],
excelStyles: [
{
id: "multiline",
alignment: {
wrapText: true,
},
},
],
};
function onBtExport() {
gridApi!.exportDataAsExcel();
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).onBtExport = onBtExport;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
gap: 16px;
}
import type { ICellRendererComp, ICellRendererParams } from 'ag-grid-community';
export class MultilineCellRenderer implements ICellRendererComp {
eGui!: HTMLDivElement;
init(params: ICellRendererParams) {
this.eGui = document.createElement('div');
this.eGui.innerHTML = params.value.replace('\n', '<br/>');
}
getGui() {
return this.eGui;
}
refresh() {
return false;
}
}
<div class="container">
<div>
<button onclick="onBtExport()" style="margin: 5px 0px; font-weight: bold">Export to Excel</button>
</div>
<div class="grid-wrapper">
<div id="myGrid"></div>
</div>
</div>
Export All Unprocessed Rows Copy Link
By default, the grid exports grid rows after filtering and sorting has been applied. This means that if you’ve filtered the grid, only the filtered rows will be exported in the order they appear in visually at the time of export.
You can override this and export all rows instead of only the filtered rows by setting the exportedRows param to ‘all’.
When exporting all rows, any column filters or sort applied to the grid are ignored and all rows are exported in the original order.
You can verify this in the example below:
- Filter the Country column to only show rows for Australia
- Sort descending by Athlete column
- Uncheck the All Rows checkbox and click the Export to Excel button
Observe how only the filtered rows are exported in the Excel file in descending order by Athlete column
- Check the All Rows checkbox and click the Export to Excel button
Observe how all rows are exported in the Excel file in the original unsorted row order
import {
ClientSideRowModelModule,
ColDef,
CsvExportModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
]);
const columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
{ headerName: "Group", valueGetter: "data.country.charAt(0)" },
{ field: "sport", minWidth: 150 },
{ field: "gold", hide: true },
{ field: "silver", hide: true },
{ field: "bronze", hide: true },
{ field: "total", hide: true },
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
defaultColDef: {
filter: true,
minWidth: 100,
flex: 1,
},
columnDefs: columnDefs,
onGridReady: (params: GridReadyEvent) => {
(document.getElementById("allRows") as HTMLInputElement).checked = true;
},
};
function onBtExport() {
gridApi!.exportDataAsExcel({
exportedRows: (document.getElementById("allRows") as HTMLInputElement)
.checked
? "all"
: "filteredAndSorted",
});
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((response) => response.json())
.then((data) =>
gridApi!.setGridOption(
"rowData",
data.filter((rec: any) => rec.country != null),
),
);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).onBtExport = onBtExport;
}
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
<div class="container">
<div class="columns">
<label class="option" for="allRows"><input id="allRows" type="checkbox" />All Rows</label>
<div>
<button onclick="onBtExport()" style="font-weight: bold">Export to Excel</button>
</div>
</div>
<div class="grid-wrapper">
<div id="myGrid"></div>
</div>
</div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Pinned Rows Copy Link
If you'd like to exclude pinned top/bottom rows in AG Grid from the Excel export, please set the skipPinnedTop and skipPinnedBottom properties to true.
Manually pinned rows also remain in the exported body by default. Set skipPinnedRowDuplicates=true to omit those body copies while retaining the rows in their pinned sections.
Note the following:
- By default, all pinned rows are exported.
- If
Skip Pinned Top Rowsis checked, the rows pinned at the top will be skipped. - If
Skip Pinned Bottom Rowsis checked, the rows pinned at the bottom will be skipped.
import {
ClientSideRowModelModule,
ColGroupDef,
CsvExportModule,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
PinnedRowModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
PinnedRowModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
]);
const columnDefs: ColGroupDef[] = [
{
headerName: "Top Level Column Group",
children: [
{
headerName: "Group A",
children: [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
{ headerName: "Group", valueGetter: "data.country.charAt(0)" },
],
},
{
headerName: "Group B",
children: [
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
},
],
},
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
defaultColDef: {
filter: true,
minWidth: 100,
flex: 1,
},
columnDefs: columnDefs,
popupParent: document.body,
pinnedTopRowData: [
{
athlete: "Floating <Top> Athlete",
country: "Floating <Top> Country",
date: "01/08/2020",
sport: "Track & Field",
gold: 22,
silver: 3,
bronze: 44,
total: 69,
} as any,
],
pinnedBottomRowData: [
{
athlete: "Floating <Bottom> Athlete",
country: "Floating <Bottom> Country",
date: "01/08/2030",
sport: "Track & Field",
gold: 222,
silver: 5,
bronze: 244,
total: 471,
} as any,
],
};
function getBoolean(id: string) {
return !!(document.querySelector("#" + id) as HTMLInputElement).checked;
}
function getParams() {
return {
skipPinnedTop: getBoolean("skipPinnedTop"),
skipPinnedBottom: getBoolean("skipPinnedBottom"),
};
}
function onBtExport() {
gridApi!.exportDataAsExcel(getParams());
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((response) => response.json())
.then((data) =>
gridApi!.setGridOption(
"rowData",
data.filter((rec: any) => rec.country != null),
),
);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).onBtExport = onBtExport;
}
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
<div class="container">
<div class="columns">
<div class="column">
<label for="skipPinnedTop"><input id="skipPinnedTop" type="checkbox" />Skip Pinned Top Rows</label>
</div>
<div class="column">
<label for="skipPinnedBottom"><input id="skipPinnedBottom" type="checkbox" />Skip Pinned Bottom Rows</label>
</div>
<div>
<button onclick="onBtExport()" style="margin: 5px 0px; font-weight: bold">Export to Excel</button>
</div>
</div>
<div class="grid-wrapper">
<div id="myGrid"></div>
</div>
</div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
}

Excel Export allows you to select which rows get exported to Excel.
By default, all the rows in the grid are included in the Excel export. However, you can set which rows are exported and configure how they are rendered within the Excel file.
Export Selected Rows Copy Link
By default, all visible rows are exported, but by using the onlySelected param, only the selected rows will be exported.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowSelectionModule,
RowSelectionOptions,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="container">
<div class="columns">
<label class="option" for="selectedOnly"><input id="selectedOnly" type="checkbox">Selected Rows Only</label>
<div>
<button v-on:click="onBtExport()" style="font-weight: bold">Export to Excel</button>
</div>
</div>
<div class="grid-wrapper">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowSelection="rowSelection"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
{ headerName: "Group", valueGetter: "data.country.charAt(0)" },
{ field: "sport", minWidth: 150 },
{ field: "gold", hide: true },
{ field: "silver", hide: true },
{ field: "bronze", hide: true },
{ field: "total", hide: true },
]);
const defaultColDef = ref<ColDef>({
filter: true,
minWidth: 100,
flex: 1,
});
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
headerCheckbox: false,
});
const rowData = ref<IOlympicData[]>(null);
function onBtExport() {
gridApi.value!.exportDataAsExcel({
onlySelected: (
document.querySelector("#selectedOnly") as HTMLInputElement
).checked,
});
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
(document.getElementById("selectedOnly") as HTMLInputElement).checked =
true;
const updateData = (data) =>
(rowData.value = data.filter((rec: any) => rec.country != null));
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowSelection,
rowData,
onGridReady,
onBtExport,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
Export Multi Line Cells Copy Link
By default Excel renders every exported value in a cell using a single line. If you need to display a cell value on multiple lines, please set the Excel Alignment wrapText option as shown in sample below.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
ExcelStyle,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
ModuleRegistry,
RowAutoHeightModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
import MultilineCellRenderer from "./multilineCellRendererVue";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
RowAutoHeightModule,
CellStyleModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="container">
<div>
<button v-on:click="onBtExport()" style="margin: 5px 0px; font-weight: bold">Export to Excel</button>
</div>
<div class="grid-wrapper">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"
:excelStyles="excelStyles"></ag-grid-vue>
</div>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
MultilineCellRenderer,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "address" },
{
headerName: "Custom column",
autoHeight: true,
valueGetter: (param) => {
return param.data.col1 + "\n" + param.data.col2;
},
cellRenderer: "MultilineCellRenderer",
},
]);
const defaultColDef = ref<ColDef>({
cellClass: "multiline",
minWidth: 100,
flex: 1,
});
const rowData = ref<any[] | null>([
{
address:
"1197 Thunder Wagon Common,\nCataract, RI, \n02987-1016, US, \n(401) 747-0763",
col1: "abc",
col2: "xyz",
},
{
address:
"3685 Rocky Glade, Showtucket, NU, \nX1E-9I0, CA, \n(867) 371-4215",
col1: "abc",
col2: "xyz",
},
{
address:
"3235 High Forest, Glen Campbell, MS, \n39035-6845, US, \n(601) 638-8186",
col1: "abc",
col2: "xyz",
},
{
address:
"2234 Sleepy Pony Mall , Drain, DC, \n20078-4243, US, \n(202) 948-3634",
col1: "abc",
col2: "xyz",
},
]);
const excelStyles = ref<ExcelStyle[]>([
{
id: "multiline",
alignment: {
wrapText: true,
},
},
]);
function onBtExport() {
gridApi.value!.exportDataAsExcel();
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
excelStyles,
onGridReady,
onBtExport,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
gap: 16px;
}
export default {
template: `<div v-html="this.params.value.replace('\\n', '<br/>')"></div>`,
};
Export All Unprocessed Rows Copy Link
By default, the grid exports grid rows after filtering and sorting has been applied. This means that if you’ve filtered the grid, only the filtered rows will be exported in the order they appear in visually at the time of export.
You can override this and export all rows instead of only the filtered rows by setting the exportedRows param to ‘all’.
When exporting all rows, any column filters or sort applied to the grid are ignored and all rows are exported in the original order.
You can verify this in the example below:
- Filter the Country column to only show rows for Australia
- Sort descending by Athlete column
- Uncheck the All Rows checkbox and click the Export to Excel button
Observe how only the filtered rows are exported in the Excel file in descending order by Athlete column
- Check the All Rows checkbox and click the Export to Excel button
Observe how all rows are exported in the Excel file in the original unsorted row order
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="container">
<div class="columns">
<label class="option" for="allRows"><input id="allRows" type="checkbox">All Rows</label>
<div>
<button v-on:click="onBtExport()" style="font-weight: bold">Export to Excel</button>
</div>
</div>
<div class="grid-wrapper">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
{ headerName: "Group", valueGetter: "data.country.charAt(0)" },
{ field: "sport", minWidth: 150 },
{ field: "gold", hide: true },
{ field: "silver", hide: true },
{ field: "bronze", hide: true },
{ field: "total", hide: true },
]);
const defaultColDef = ref<ColDef>({
filter: true,
minWidth: 100,
flex: 1,
});
const rowData = ref<IOlympicData[]>(null);
function onBtExport() {
gridApi.value!.exportDataAsExcel({
exportedRows: (document.getElementById("allRows") as HTMLInputElement)
.checked
? "all"
: "filteredAndSorted",
});
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
(document.getElementById("allRows") as HTMLInputElement).checked = true;
const updateData = (data) =>
(rowData.value = data.filter((rec: any) => rec.country != null));
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
onBtExport,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
Pinned Rows Copy Link
If you'd like to exclude pinned top/bottom rows in AG Grid from the Excel export, please set the skipPinnedTop and skipPinnedBottom properties to true.
Manually pinned rows also remain in the exported body by default. Set skipPinnedRowDuplicates=true to omit those body copies while retaining the rows in their pinned sections.
Note the following:
- By default, all pinned rows are exported.
- If
Skip Pinned Top Rowsis checked, the rows pinned at the top will be skipped. - If
Skip Pinned Bottom Rowsis checked, the rows pinned at the bottom will be skipped.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
PinnedRowModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
PinnedRowModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
]);
function getBoolean(id: string) {
return !!(document.querySelector("#" + id) as HTMLInputElement).checked;
}
function getParams() {
return {
skipPinnedTop: getBoolean("skipPinnedTop"),
skipPinnedBottom: getBoolean("skipPinnedBottom"),
};
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="container">
<div class="columns">
<div class="column">
<label for="skipPinnedTop"><input id="skipPinnedTop" type="checkbox">Skip Pinned Top Rows</label>
</div>
<div class="column">
<label for="skipPinnedBottom"><input id="skipPinnedBottom" type="checkbox">Skip Pinned Bottom Rows</label>
</div>
<div>
<button v-on:click="onBtExport()" style="margin: 5px 0px; font-weight: bold">Export to Excel</button>
</div>
</div>
<div class="grid-wrapper">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:popupParent="popupParent"
:pinnedTopRowData="pinnedTopRowData"
:pinnedBottomRowData="pinnedBottomRowData"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<(ColDef | ColGroupDef)[]>([
{
headerName: "Top Level Column Group",
children: [
{
headerName: "Group A",
children: [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
{ headerName: "Group", valueGetter: "data.country.charAt(0)" },
],
},
{
headerName: "Group B",
children: [
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
},
],
},
]);
const defaultColDef = ref<ColDef>({
filter: true,
minWidth: 100,
flex: 1,
});
const popupParent = ref<HTMLElement | null>(document.body);
const pinnedTopRowData = ref<any[]>([
{
athlete: "Floating <Top> Athlete",
country: "Floating <Top> Country",
date: "01/08/2020",
sport: "Track & Field",
gold: 22,
silver: 3,
bronze: 44,
total: 69,
} as any,
]);
const pinnedBottomRowData = ref<any[]>([
{
athlete: "Floating <Bottom> Athlete",
country: "Floating <Bottom> Country",
date: "01/08/2030",
sport: "Track & Field",
gold: 222,
silver: 5,
bronze: 244,
total: 471,
} as any,
]);
const rowData = ref<IOlympicData[]>(null);
function onBtExport() {
gridApi.value!.exportDataAsExcel(getParams());
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) =>
(rowData.value = data.filter((rec: any) => rec.country != null));
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
popupParent,
pinnedTopRowData,
pinnedBottomRowData,
rowData,
onGridReady,
onBtExport,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}

Excel Export allows you to select which rows get exported to Excel.
By default, all the rows in the grid are included in the Excel export. However, you can set which rows are exported and configure how they are rendered within the Excel file.
Export Selected Rows Copy Link
By default, all visible rows are exported, but by using the onlySelected param, only the selected rows will be exported.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowSelectionModule,
RowSelectionOptions,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="container">
<div class="columns">
<label class="option" for="selectedOnly"
><input id="selectedOnly" type="checkbox" />Selected Rows Only</label
>
<div>
<button (click)="onBtExport()" style="font-weight: bold">
Export to Excel
</button>
</div>
</div>
<div class="grid-wrapper">
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowSelection]="rowSelection"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IOlympicData>;
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
{ headerName: "Group", valueGetter: "data.country.charAt(0)" },
{ field: "sport", minWidth: 150 },
{ field: "gold", hide: true },
{ field: "silver", hide: true },
{ field: "bronze", hide: true },
{ field: "total", hide: true },
];
defaultColDef: ColDef = {
filter: true,
minWidth: 100,
flex: 1,
};
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
headerCheckbox: false,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onBtExport() {
this.gridApi.exportDataAsExcel({
onlySelected: (
document.querySelector("#selectedOnly") as HTMLInputElement
).checked,
});
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.gridApi = params.api;
(document.getElementById("selectedOnly") as HTMLInputElement).checked =
true;
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.subscribe(
(data) =>
(this.rowData = data.filter((rec: any) => rec.country != null)),
);
}
}
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Export Multi Line Cells Copy Link
By default Excel renders every exported value in a cell using a single line. If you need to display a cell value on multiple lines, please set the Excel Alignment wrapText option as shown in sample below.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
ExcelStyle,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
ModuleRegistry,
RowAutoHeightModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
RowAutoHeightModule,
CellStyleModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
]);
import { MultilineCellRenderer } from "./multiline-cell-renderer.component";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular, MultilineCellRenderer],
template: `<div class="container">
<div>
<button (click)="onBtExport()" style="margin: 5px 0px; font-weight: bold">
Export to Excel
</button>
</div>
<div class="grid-wrapper">
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
[excelStyles]="excelStyles"
(gridReady)="onGridReady($event)"
/>
</div>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi;
columnDefs: ColDef[] = [
{ field: "address" },
{
headerName: "Custom column",
autoHeight: true,
valueGetter: (param) => {
return param.data.col1 + "\n" + param.data.col2;
},
cellRenderer: MultilineCellRenderer,
},
];
defaultColDef: ColDef = {
cellClass: "multiline",
minWidth: 100,
flex: 1,
};
rowData: any[] | null = [
{
address:
"1197 Thunder Wagon Common,\nCataract, RI, \n02987-1016, US, \n(401) 747-0763",
col1: "abc",
col2: "xyz",
},
{
address:
"3685 Rocky Glade, Showtucket, NU, \nX1E-9I0, CA, \n(867) 371-4215",
col1: "abc",
col2: "xyz",
},
{
address:
"3235 High Forest, Glen Campbell, MS, \n39035-6845, US, \n(601) 638-8186",
col1: "abc",
col2: "xyz",
},
{
address:
"2234 Sleepy Pony Mall , Drain, DC, \n20078-4243, US, \n(202) 948-3634",
col1: "abc",
col2: "xyz",
},
];
excelStyles: ExcelStyle[] = [
{
id: "multiline",
alignment: {
wrapText: true,
},
},
];
onBtExport() {
this.gridApi.exportDataAsExcel();
}
onGridReady(params: GridReadyEvent) {
this.gridApi = params.api;
}
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
gap: 16px;
}
import { ChangeDetectionStrategy, Component, signal } from '@angular/core';
import type { ICellRendererAngularComp } from 'ag-grid-angular';
import type { ICellRendererParams } from 'ag-grid-community';
@Component({
standalone: true,
changeDetection: ChangeDetectionStrategy.OnPush,
// using innerHTML to preserve the line breaks
template: `<div [innerHTML]="value()"></div>`,
})
export class MultilineCellRenderer implements ICellRendererAngularComp {
value = signal<string>('');
agInit(params: ICellRendererParams): void {
this.value.set(params.value.replace('\n', '<br/>'));
}
refresh() {
return false;
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Export All Unprocessed Rows Copy Link
By default, the grid exports grid rows after filtering and sorting has been applied. This means that if you’ve filtered the grid, only the filtered rows will be exported in the order they appear in visually at the time of export.
You can override this and export all rows instead of only the filtered rows by setting the exportedRows param to ‘all’.
When exporting all rows, any column filters or sort applied to the grid are ignored and all rows are exported in the original order.
You can verify this in the example below:
- Filter the Country column to only show rows for Australia
- Sort descending by Athlete column
- Uncheck the All Rows checkbox and click the Export to Excel button
Observe how only the filtered rows are exported in the Excel file in descending order by Athlete column
- Check the All Rows checkbox and click the Export to Excel button
Observe how all rows are exported in the Excel file in the original unsorted row order
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="container">
<div class="columns">
<label class="option" for="allRows"
><input id="allRows" type="checkbox" />All Rows</label
>
<div>
<button (click)="onBtExport()" style="font-weight: bold">
Export to Excel
</button>
</div>
</div>
<div class="grid-wrapper">
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IOlympicData>;
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
{ headerName: "Group", valueGetter: "data.country.charAt(0)" },
{ field: "sport", minWidth: 150 },
{ field: "gold", hide: true },
{ field: "silver", hide: true },
{ field: "bronze", hide: true },
{ field: "total", hide: true },
];
defaultColDef: ColDef = {
filter: true,
minWidth: 100,
flex: 1,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onBtExport() {
this.gridApi.exportDataAsExcel({
exportedRows: (document.getElementById("allRows") as HTMLInputElement)
.checked
? "all"
: "filteredAndSorted",
});
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.gridApi = params.api;
(document.getElementById("allRows") as HTMLInputElement).checked = true;
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.subscribe(
(data) =>
(this.rowData = data.filter((rec: any) => rec.country != null)),
);
}
}
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Pinned Rows Copy Link
If you'd like to exclude pinned top/bottom rows in AG Grid from the Excel export, please set the skipPinnedTop and skipPinnedBottom properties to true.
Manually pinned rows also remain in the exported body by default. Set skipPinnedRowDuplicates=true to omit those body copies while retaining the rows in their pinned sections.
Note the following:
- By default, all pinned rows are exported.
- If
Skip Pinned Top Rowsis checked, the rows pinned at the top will be skipped. - If
Skip Pinned Bottom Rowsis checked, the rows pinned at the bottom will be skipped.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
PinnedRowModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
PinnedRowModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="container">
<div class="columns">
<div class="column">
<label for="skipPinnedTop"
><input id="skipPinnedTop" type="checkbox" />Skip Pinned Top
Rows</label
>
</div>
<div class="column">
<label for="skipPinnedBottom"
><input id="skipPinnedBottom" type="checkbox" />Skip Pinned Bottom
Rows</label
>
</div>
<div>
<button
(click)="onBtExport()"
style="margin: 5px 0px; font-weight: bold"
>
Export to Excel
</button>
</div>
</div>
<div class="grid-wrapper">
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[popupParent]="popupParent"
[pinnedTopRowData]="pinnedTopRowData"
[pinnedBottomRowData]="pinnedBottomRowData"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IOlympicData>;
columnDefs: (ColDef | ColGroupDef)[] = [
{
headerName: "Top Level Column Group",
children: [
{
headerName: "Group A",
children: [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
{ headerName: "Group", valueGetter: "data.country.charAt(0)" },
],
},
{
headerName: "Group B",
children: [
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
},
],
},
];
defaultColDef: ColDef = {
filter: true,
minWidth: 100,
flex: 1,
};
popupParent: HTMLElement | null = document.body;
pinnedTopRowData: any[] = [
{
athlete: "Floating <Top> Athlete",
country: "Floating <Top> Country",
date: "01/08/2020",
sport: "Track & Field",
gold: 22,
silver: 3,
bronze: 44,
total: 69,
} as any,
];
pinnedBottomRowData: any[] = [
{
athlete: "Floating <Bottom> Athlete",
country: "Floating <Bottom> Country",
date: "01/08/2030",
sport: "Track & Field",
gold: 222,
silver: 5,
bronze: 244,
total: 471,
} as any,
];
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onBtExport() {
this.gridApi.exportDataAsExcel(getParams());
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.gridApi = params.api;
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.subscribe(
(data) =>
(this.rowData = data.filter((rec: any) => rec.country != null)),
);
}
}
function getBoolean(id: string) {
return !!(document.querySelector("#" + id) as HTMLInputElement).checked;
}
function getParams() {
return {
skipPinnedTop: getBoolean("skipPinnedTop"),
skipPinnedBottom: getBoolean("skipPinnedBottom"),
};
}
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
}

Excel Export allows you to select which rows get exported to Excel.
By default, all the rows in the grid are included in the Excel export. However, you can set which rows are exported and configure how they are rendered within the Excel file.
Export Selected Rows Copy Link
By default, all visible rows are exported, but by using the onlySelected param, only the selected rows will be exported.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowSelectionModule,
RowSelectionOptions,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextFilterModule,
NumberFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
];
const GridExample = () => {
const gridRef = useRef<AgGridReact<IOlympicData>>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<IOlympicData[]>();
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
{ headerName: "Group", valueGetter: "data.country.charAt(0)" },
{ field: "sport", minWidth: 150 },
{ field: "gold", hide: true },
{ field: "silver", hide: true },
{ field: "bronze", hide: true },
{ field: "total", hide: true },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
filter: true,
minWidth: 100,
flex: 1,
};
}, []);
const rowSelection = useMemo<
RowSelectionOptions | "single" | "multiple"
>(() => {
return {
mode: "multiRow",
headerCheckbox: false,
};
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((resp) => resp.json())
.then((data: IOlympicData[]) =>
setRowData(data.filter((rec: any) => rec.country != null)),
);
(document.getElementById("selectedOnly") as HTMLInputElement).checked =
true;
}, []);
const onBtExport = useCallback(() => {
gridRef.current!.api.exportDataAsExcel({
onlySelected: (
document.querySelector("#selectedOnly") as HTMLInputElement
).checked,
});
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="container">
<div className="columns">
<label className="option" htmlFor="selectedOnly">
<input id="selectedOnly" type="checkbox" />
Selected Rows Only
</label>
<div>
<button onClick={onBtExport} style={{ fontWeight: "bold" }}>
Export to Excel
</button>
</div>
</div>
<div className="grid-wrapper">
<div style={gridStyle}>
<AgGridReact<IOlympicData>
ref={gridRef}
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowSelection={rowSelection}
onGridReady={onGridReady}
/>
</div>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Export Multi Line Cells Copy Link
By default Excel renders every exported value in a cell using a single line. If you need to display a cell value on multiple lines, please set the Excel Alignment wrapText option as shown in sample below.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
ExcelStyle,
GridApi,
GridOptions,
ICellRendererParams,
ModuleRegistry,
RowAutoHeightModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
import MultilineCellRenderer from "./multilineCellRenderer.tsx";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
RowAutoHeightModule,
CellStyleModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
];
const GridExample = () => {
const gridRef = useRef<AgGridReact>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>([
{
address:
"1197 Thunder Wagon Common,\nCataract, RI, \n02987-1016, US, \n(401) 747-0763",
col1: "abc",
col2: "xyz",
},
{
address:
"3685 Rocky Glade, Showtucket, NU, \nX1E-9I0, CA, \n(867) 371-4215",
col1: "abc",
col2: "xyz",
},
{
address:
"3235 High Forest, Glen Campbell, MS, \n39035-6845, US, \n(601) 638-8186",
col1: "abc",
col2: "xyz",
},
{
address:
"2234 Sleepy Pony Mall , Drain, DC, \n20078-4243, US, \n(202) 948-3634",
col1: "abc",
col2: "xyz",
},
]);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "address" },
{
headerName: "Custom column",
autoHeight: true,
valueGetter: (param) => {
return param.data.col1 + "\n" + param.data.col2;
},
cellRenderer: MultilineCellRenderer,
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
cellClass: "multiline",
minWidth: 100,
flex: 1,
};
}, []);
const excelStyles = useMemo<ExcelStyle[]>(() => {
return [
{
id: "multiline",
alignment: {
wrapText: true,
},
},
];
}, []);
const onBtExport = useCallback(() => {
gridRef.current!.api.exportDataAsExcel();
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="container">
<div>
<button
onClick={onBtExport}
style={{ margin: "5px 0px", fontWeight: "bold" }}
>
Export to Excel
</button>
</div>
<div className="grid-wrapper">
<div style={gridStyle}>
<AgGridReact
ref={gridRef}
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
excelStyles={excelStyles}
/>
</div>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
gap: 16px;
}
import React from 'react';
import type { CustomCellRendererProps } from 'ag-grid-react';
export default (props: CustomCellRendererProps) => (
<div dangerouslySetInnerHTML={{ __html: props.value.replace('\n', '<br/>') }}></div>
);
Export All Unprocessed Rows Copy Link
By default, the grid exports grid rows after filtering and sorting has been applied. This means that if you’ve filtered the grid, only the filtered rows will be exported in the order they appear in visually at the time of export.
You can override this and export all rows instead of only the filtered rows by setting the exportedRows param to ‘all’.
When exporting all rows, any column filters or sort applied to the grid are ignored and all rows are exported in the original order.
You can verify this in the example below:
- Filter the Country column to only show rows for Australia
- Sort descending by Athlete column
- Uncheck the All Rows checkbox and click the Export to Excel button
Observe how only the filtered rows are exported in the Excel file in descending order by Athlete column
- Check the All Rows checkbox and click the Export to Excel button
Observe how all rows are exported in the Excel file in the original unsorted row order
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextFilterModule,
NumberFilterModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
];
const GridExample = () => {
const gridRef = useRef<AgGridReact<IOlympicData>>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<IOlympicData[]>();
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
{ headerName: "Group", valueGetter: "data.country.charAt(0)" },
{ field: "sport", minWidth: 150 },
{ field: "gold", hide: true },
{ field: "silver", hide: true },
{ field: "bronze", hide: true },
{ field: "total", hide: true },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
filter: true,
minWidth: 100,
flex: 1,
};
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((resp) => resp.json())
.then((data: IOlympicData[]) =>
setRowData(data.filter((rec: any) => rec.country != null)),
);
(document.getElementById("allRows") as HTMLInputElement).checked = true;
}, []);
const onBtExport = useCallback(() => {
gridRef.current!.api.exportDataAsExcel({
exportedRows: (document.getElementById("allRows") as HTMLInputElement)
.checked
? "all"
: "filteredAndSorted",
});
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="container">
<div className="columns">
<label className="option" htmlFor="allRows">
<input id="allRows" type="checkbox" />
All Rows
</label>
<div>
<button onClick={onBtExport} style={{ fontWeight: "bold" }}>
Export to Excel
</button>
</div>
</div>
<div className="grid-wrapper">
<div style={gridStyle}>
<AgGridReact<IOlympicData>
ref={gridRef}
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
onGridReady={onGridReady}
/>
</div>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Pinned Rows Copy Link
If you'd like to exclude pinned top/bottom rows in AG Grid from the Excel export, please set the skipPinnedTop and skipPinnedBottom properties to true.
Manually pinned rows also remain in the exported body by default. Set skipPinnedRowDuplicates=true to omit those body copies while retaining the rows in their pinned sections.
Note the following:
- By default, all pinned rows are exported.
- If
Skip Pinned Top Rowsis checked, the rows pinned at the top will be skipped. - If
Skip Pinned Bottom Rowsis checked, the rows pinned at the bottom will be skipped.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CsvExportModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
PinnedRowModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextFilterModule,
NumberFilterModule,
PinnedRowModule,
ClientSideRowModelModule,
CsvExportModule,
ExcelExportModule,
ColumnMenuModule,
ContextMenuModule,
];
function getBoolean(id: string) {
return !!(document.querySelector("#" + id) as HTMLInputElement).checked;
}
function getParams() {
return {
skipPinnedTop: getBoolean("skipPinnedTop"),
skipPinnedBottom: getBoolean("skipPinnedBottom"),
};
}
const GridExample = () => {
const gridRef = useRef<AgGridReact<IOlympicData>>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<IOlympicData[]>();
const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
{
headerName: "Top Level Column Group",
children: [
{
headerName: "Group A",
children: [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
{ headerName: "Group", valueGetter: "data.country.charAt(0)" },
],
},
{
headerName: "Group B",
children: [
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
},
],
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
filter: true,
minWidth: 100,
flex: 1,
};
}, []);
const popupParent = useMemo<HTMLElement | null>(() => {
return document.body;
}, []);
const pinnedTopRowData = useMemo<any[]>(() => {
return [
{
athlete: "Floating <Top> Athlete",
country: "Floating <Top> Country",
date: "01/08/2020",
sport: "Track & Field",
gold: 22,
silver: 3,
bronze: 44,
total: 69,
} as any,
];
}, []);
const pinnedBottomRowData = useMemo<any[]>(() => {
return [
{
athlete: "Floating <Bottom> Athlete",
country: "Floating <Bottom> Country",
date: "01/08/2030",
sport: "Track & Field",
gold: 222,
silver: 5,
bronze: 244,
total: 471,
} as any,
];
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((resp) => resp.json())
.then((data: IOlympicData[]) =>
setRowData(data.filter((rec: any) => rec.country != null)),
);
}, []);
const onBtExport = useCallback(() => {
gridRef.current!.api.exportDataAsExcel(getParams());
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="container">
<div className="columns">
<div className="column">
<label htmlFor="skipPinnedTop">
<input id="skipPinnedTop" type="checkbox" />
Skip Pinned Top Rows
</label>
</div>
<div className="column">
<label htmlFor="skipPinnedBottom">
<input id="skipPinnedBottom" type="checkbox" />
Skip Pinned Bottom Rows
</label>
</div>
<div>
<button
onClick={onBtExport}
style={{ margin: "5px 0px", fontWeight: "bold" }}
>
Export to Excel
</button>
</div>
</div>
<div className="grid-wrapper">
<div style={gridStyle}>
<AgGridReact<IOlympicData>
ref={gridRef}
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
popupParent={popupParent}
pinnedTopRowData={pinnedTopRowData}
pinnedBottomRowData={pinnedBottomRowData}
onGridReady={onGridReady}
/>
</div>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.details > label {
margin-bottom: 10px;
}
.details > label:first-of-type {
margin-top: 10px;
}
.details > label:last-of-type {
margin-bottom: 0;
}
.option {
display: block;
margin: 5px 10px 5px 0;
}
.grid-wrapper {
display: flex;
flex: 1 1 0px;
}
.grid-wrapper > div {
width: 100%;
height: 100%;
}
.container {
display: flex;
flex-direction: column;
height: 100%;
}
.columns {
display: flex;
flex-direction: row;
align-items: center;
gap: 16px;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
}